<?php
/*
Plugin Name: InstaGenius
Description: This WP plugin displays a coupon/special/discount type icon/image prompting people to search to find specials  - and then performs followups for subscribers when products go on sale
Version: 0.0.44
Author: Wildfire Concepts
Author URI: http://wildfireconcepts.com/
*/
define('IG_VERSION', '0.0.44');
define('IG_FOLDER', 'InstaGenius');
define('IG_PREFIX', 'igen_');
class IG_InstaGenius{
	/**
	* This value will be used for 
	* - the gettext textdomain 
	* - the subfolder when adding scripts and styles
	* - the handle for scripts and styles
	* Please make sure that this value corresponds to the folder name where your plugin resides.
	* @var string 
	*/
	var $plugin_name = "";
	var $plugin_url = "";
	var $update;
	var $options = Array();
	/**
	* The constructor is executed when the class is instatiated and the plugin gets loaded.
	* @return void
	*/
	function IG_InstaGenius() {
		$this->plugin_name = IG_FOLDER;
		if ( in_array( $GLOBALS['pagenow'], array( 'wp-login.php', 'wp-register.php' ) ) )
			return;
		$this->plugin_url = plugins_url(basename( dirname( __FILE__)));
		if(is_admin()){
			add_filter('pre_set_site_transient_update_plugins',array(&$this, 'get_update_info'));
			add_action('admin_menu', array(&$this,'instagenius_admin_menu'));
			add_action('admin_init', array(&$this,'init_admin'));
			add_action( 'add_meta_boxes', array(&$this,'ig_hideicon_meta_add') );
			add_action( 'save_post', array(&$this,'cd_meta_box_save') );
			wp_enqueue_media();
			add_action("upgrader_process_complete", function( $upgrader_object, $options ) {
				IG_InstaGenius::install_db(); 
			}, 10, 2 );

			
		} else {
			add_filter('wp_enqueue_scripts', array(&$this, 'init_front'));
			add_filter('wp_footer', array(&$this, 'add_to_content'), '10');
			add_action('wp_footer', array(&$this, 'icon_to_footer'));
			add_shortcode('ig_icon_display', array(&$this, 'icon_to_footer_dummy'));
			add_action('wp_header', array(&$this, 'add_header'));
		}
	}
	/**
	* This function is executed when the plugin is activated. To activate it just uncomment
	* the line at the bottom of this file with the register_activation_hook( ... ) function 
	* @return void
	*/
	function install() {
		IG_InstaGenius::install_db(); 
	}
	/**
	* This function is executed from install( ) and is used if you need database tables.
	* @return void
	*/
	function install_db() {
		global $wpdb;
		/**
		* To create tables, dbDelta from wp-admin/includes/upgrade.php is needed
		*/
		//update_option("ig_activation_key",'');
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		$current_version = null;
		// Define tables
		$tables = array('ig_email_template', 'ig_subscribed_products', 'ig_store_products');
		$structure = array(
			"(`id` int(11) NOT NULL AUTO_INCREMENT,
			  `template_name` varchar(255) NOT NULL,
			  `template_val` varchar(255) NOT NULL,
			  `template_subject` text NOT NULL,
			  `template_body` text NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=MyISAM  AUTO_INCREMENT=1", 
			
			"(`id` int(11) NOT NULL AUTO_INCREMENT,
			  `asin` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
			  `price` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
			  `region` varchar(10) COLLATE utf8_unicode_ci NOT NULL,
			  `user_id` int(11) NOT NULL,
			  `timestamp` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
			  `price_drop_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
			  `is_followup_1day` tinyint(4) NOT NULL DEFAULT '0',
			  `is_followup_7day` tinyint(4) NOT NULL DEFAULT '0',
			  `is_recommended_14day` tinyint(4) NOT NULL DEFAULT '0',
			  `is_recommended_7day` tinyint(4) NOT NULL DEFAULT '0',
			  `is_subscriber_30day` tinyint(4) NOT NULL DEFAULT '0',
			  `subscription_mail_sentdate` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
			  PRIMARY KEY (`id`)
			)",
			
			"(`id` int(11) NOT NULL AUTO_INCREMENT,
			  `prod_image` text COLLATE utf8_unicode_ci NOT NULL,
			  `prod_name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
			  `prod_desc` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
			  `prod_url` text COLLATE utf8_unicode_ci NOT NULL,
			  `prod_price` decimal(10,2) NOT NULL,
			  `prod_tags` text COLLATE utf8_unicode_ci NOT NULL,
			  PRIMARY KEY (`id`)
			)"
			
		);
		// Upgrade routine from DB version 1 
		$upgrade = Array();
		// Iterate tables and create them
		$i=0;
		foreach ($tables as $key => $table) {			
			if($wpdb->get_var(sprintf("SHOW TABLES LIKE '%s%s'", $wpdb->prefix, $table)) != $wpdb->prefix . $table) {
				// Table doesn't exist, create it.
				$sql = sprintf("CREATE TABLE %s%s %s DEFAULT CHARSET=utf8", $wpdb->prefix, $table, $structure[$key]);
				dbDelta($sql);
			}
		}
		
		$table_name = $wpdb->prefix . 'ig_email_template';
		
		$ig_email_templates_array = array();
		$ig_email_templates_array[] = array('template_name' => 'Welcome Email - Triggered Immediately On Subscribe', 'template_val' => 'on_subscribe', 'template_subject' => '[site_name]\'s on the look out for you!', 'template_body' => '<p>Hey [subscriber_name]</p><p>We\'ve started watching for any price drops for [product_name] and related products for you.</p>If you\'d like to change the the items we\'re watching for you, you can do that at any time here: </p>=&gt; [manage_subscriptions]</p><p>Happy shopping,</p>[admin_username]</p><p>[site_name]</p><p>[manage_subscriptions]</p>');
		$ig_email_templates_array[] = array('template_name' => 'Price Drop Email - Triggered Immediately On Price Drop', 'template_val' => 'price_drop', 'template_subject' => 'Lucky you! Your [site_name] search just found you a bargain.', 'template_body' => '<p>Hey [subscriber_name]</p><p>We\'ve been keeping an eye out for some good deals for [product_name] and you\'re in luck.</p><p>The price has dropped, so now is a great time to grab it while it\'s at a record low.</p><p>=> [product_link]</p><br/><p>Happy shopping,</p><p>[admin_username]</p><p>[site_name]</p><p>[manage_subscriptions]</p>');
		$ig_email_templates_array[] = array('template_name' => 'Followup Email - Triggered 1 Day After Price Drop', 'template_val' => 'followup_1day', 'template_subject' => 'Did you see the [product_name] discount yet?', 'template_body' => '<p>Hey [subscriber_name]</p><p>I just wanted to check in and see how you went with the [product_name]</p><p>Did you have a chance to have a look?</p><p>It would be a shame to miss out...</p><p>=&gt; [product_link]</p><br /><p>Happy shopping,</p><p>[admin_username]</p><p>[site_name]</p><p>[manage_subscriptions]</p>');
		$ig_email_templates_array[] = array('template_name' => 'Followup Email - Triggered 7 Days After First Price Drop', 'template_val' => 'followup_7day', 'template_subject' => 'Did you still want [product_name]?', 'template_body' => '<p>We found a great deal for you, were you still interested?</p><p>=&gt; [product_link]</p><p>or if you don\'t want [product_name] anymore, maybe you\'d rather these?</p><p>[recommended_products]</p><br /><p>Happy shopping,</p><p>[admin_username]</p><p>[site_name]</p><p>[manage_subscriptions]</p>');
		$ig_email_templates_array[] = array('template_name' => 'Recommended Products - Triggered 14 Days After Price Drop', 'template_val' => 'recommended_14day', 'template_subject' => 'Your Handpicked Bargains', 'template_body' => '<p>You mentioned you were interested in [product_name]\'s</p><p>I\'ve taken the liberty of finding some great deals for you today,</p><p>check them out here:</p><p>[recommended_products]</p><br /><p>Happy shopping,</p><p>[admin_username]</p><p>[site_name]</p><p>[manage_subscriptions]</p>');
		$ig_email_templates_array[] = array('template_name' => 'Recommended Products - Triggered 7 Days After Subscribe If NO Price Drop Happens', 'template_val' => 'recommended_7day', 'template_subject' => 'Your Handpicked Bargains', 'template_body' => '<p>We\'ve been looking for a better price for [product] but haven\'t had any luck (yet!)</p><p>We\'ll keep searching for you, but we came across this today and thought you might like it:</p><p>[recommended_products]</p><br /><p>Happy shopping,</p><p>[admin_username]</p><p>[site_name]</p><p>[manage_subscriptions]</p>');
		$ig_email_templates_array[] = array('template_name' => 'Checking Subscriptions - Triggered every 30 days after user subscribes', 'template_val' => 'subscriber_30day', 'template_subject' => 'Have you found what you\'re looking for?', 'template_body' => '<p>We\'ve all about helping you save cash and wanted to check in and see if there are any products you\'d like us to watch for you?</p><p>Here are the items we\'re watching for you now:</p><p>=&gt; Click here to update [manage_subscriptions]</p><br /><p>Happy shopping,</p><p>[admin_username]</p><p>[site_name]</p>');
		
		//check if already exist
		//echo "select template_val from ".$table_name."";
		$total_records_email_template = $wpdb->get_results("select template_val from ".$table_name."");
		/*echo '<hr>';
		echo sizeof($total_records_email_template);
		echo '<hr>';
		*/
		if(sizeof($total_records_email_template) > 7){
			//echo "truncate table ".$table_name."";
			$wpdb->query("truncate table ".$table_name."");
		}
		
		foreach($ig_email_templates_array as $ig_email_templates_array){
			//check if already exist same record
			//echo "select template_val from ".$table_name." where template_val = '".$ig_email_templates_array['template_val']."'";
			
			$check_exist_same_emailtemp = $wpdb->get_results("select template_val from ".$table_name." where template_val = '".$ig_email_templates_array['template_val']."'");
			if(!$check_exist_same_emailtemp){
			//echo 'insert';
			$wpdb->insert( 
				$table_name, 
				array( 
					'template_name' => $ig_email_templates_array['template_name'], 
					'template_val' => $ig_email_templates_array['template_val'], 
					'template_subject' => $ig_email_templates_array['template_subject'],
					'template_body' => $ig_email_templates_array['template_body']
					) 
			);
			}
		}
		

	}
	/**
	* Register the admin option page stylesheet and scripts
	*/
	function init_admin() {
		$rand = rand(0,9);
		wp_register_style($this->plugin_name . '-page-stylesheet', $this->plugin_url.'/includes/admin_style.css');
		wp_register_script($this->plugin_name . '-script', $this->plugin_url.'/includes/admin_script.js', array('jquery'), '1.'.$rand);
		wp_register_script($this->plugin_name . '-custombox', $this->plugin_url.'/includes/custombox/custombox.min.js', array('jquery'), '1.'.$rand);
		wp_register_script($this->plugin_name . '-jq-accordian-js', '//code.jquery.com/ui/1.12.1/jquery-ui.js', array('jquery'), '1.'.$rand);
		wp_register_style($this->plugin_name . '-custombox-stylesheet', $this->plugin_url.'/includes/custombox/custombox.min.css');
		wp_register_style($this->plugin_name . '-jq-accordian', '//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css');
		
	}
	function init_front(){
		$rand = rand(0,9);
		wp_register_style($this->plugin_name . '-page-stylesheet', $this->plugin_url.'/includes/front_style.css',array(), '1.'.$rand);
		wp_register_script($this->plugin_name . '-custombox', $this->plugin_url.'/includes/custombox/custombox.min.js', array('jquery'), '1.'.$rand);
		wp_register_style($this->plugin_name . '-custombox-stylesheet', $this->plugin_url.'/includes/custombox/custombox.min.css');
		wp_register_script($this->plugin_name . '-script', $this->plugin_url.'/includes/front_script.js', array('jquery'), '1.'.$rand);
		//wp_enqueue_script( 'ajax_custom_script',  get_stylesheet_directory_uri() . '/includes/ajax-javascript.js', array('jquery') );
		wp_localize_script( $this->plugin_name . '-script', 'frontendajax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' )));
		wp_enqueue_style($this->plugin_name . '-page-stylesheet');
		wp_enqueue_script($this->plugin_name . '-custombox');
		wp_enqueue_script($this->plugin_name . '-script');		
		wp_enqueue_style($this->plugin_name . '-custombox-stylesheet');
	}
	/*
	* Will only be called on our plugin admin page, enqueue our stylesheet here
	*/
	function load_admin_styles() {
		wp_enqueue_style($this->plugin_name . '-page-stylesheet');
		wp_enqueue_style($this->plugin_name . '-jq-accordian');
		wp_enqueue_script($this->plugin_name . '-jq-accordian-js');
		wp_enqueue_script($this->plugin_name . '-custombox');
		wp_enqueue_style( 'wp-color-picker');
        wp_enqueue_script( 'wp-color-picker');
	}
	/**
	* Loading the Admin side scripts
	* @return void
	*/
	function load_admin_scripts() {
		// Only enqueue scripts on frontend. 
		wp_enqueue_script('jquery');
		wp_enqueue_script($this->plugin_name . '-script');
		wp_localize_script('instagenius_admin_options_script', 'IMWB_CGT_Ajax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'nonce' => wp_create_nonce( 'cb_clear_cookie_nonce' ), 'plugin_url' => $this->plugin_url, 'wp_root' => $this->get_wp_root_path() ) );
		wp_enqueue_style($this->plugin_name . '-custombox-stylesheet');
		wp_enqueue_script( 'farbtastic' );
	}
	/**
	* Adds a new menu with the name "My Admin Menu" and let's anyone that
	* can publish posts be able to use it. 
	* @return void
	*/
	function instagenius_admin_menu() {
		// Add the menu page
		$hook_name = add_menu_page( 'InstaGenius Admin Menu',
			'InstaGenius',
			'manage_options',
			$this->plugin_name . '-admin-menu',
			array(&$this, 'load_main_page'), 
			plugins_url("includes/images/iglogosquare-sml.png",__FILE__),
			383);
		add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
		add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));		
		
		$hook_name = add_submenu_page($this->plugin_name . '-admin-menu', 'InstaGenius Settings', 'Settings', 'manage_options', $this->plugin_name . '-admin-menu', array(&$this, 'load_main_page'));
		add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
		add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));	
		
		$hook_name = add_submenu_page($this->plugin_name . '-admin-menu', 'Genius Store', 'Genius Store', 'manage_options', $this->plugin_name . '-geniusstore_page', array(&$this, 'geniusstore_page'));
		add_action( 'admin_print_styles-' . $hook_name, array(&$this, 'load_admin_styles'));
		add_action( 'admin_print_scripts-' . $hook_name, array(&$this, 'load_admin_scripts'));	
		
	}
	function load_main_page(){ require "pages/ig_settings.php"; }
	function campaigns_page(){ require "pages/ig_campaigns.php"; }
	function geniusstore_page(){ require "pages/ig_genius_store.php"; }
	function get_wp_root_path(){
		$path = parse_url(get_bloginfo('wpurl'), PHP_URL_PATH);
		if(!isset($path))
			return '/';
		else
			return $path;
	}
	function icon_to_footer_dummy(){
		return '';
	}
	function icon_to_footer(){
		
		$meta_val = get_post_meta(get_the_ID(), 'ig_hide_icon_check', true);
		$get_data = get_option('InstaGenius-AdminOptions');
		$vertical_position = $get_data['vertical_position'];
		$horizontal_position = $get_data['horizontal_position'];
		if($vertical_position == ''){
			$vertical_position = 'center';
		}
		if($horizontal_position == ''){
			$horizontal_position = 'center';
		}
		if($get_data['after_x_seconds'] >= 1){
			$timetoopen = $get_data['after_x_seconds']*1000;
			echo '<script>setTimeout(function(){ig_modal_open("'.$vertical_position.'","'.$horizontal_position.'");},'.$timetoopen.');</script>';
		}
		if($get_data['icon_onload'] == 'yes'){
			echo '<script>window.onload = function(){ig_modal_open("'.$vertical_position.'","'.$horizontal_position.'");};</script>';
		}
		if(is_category()) {
			$icon_to_dispaly = $get_data['icon_categories'];
		} else {
			if($meta_val!='1') {
				if(is_home() || is_front_page()) {
					$icon_to_dispaly = $get_data['icon_onhome'];
				} else if ( is_singular('post') ) {
					$icon_to_dispaly = $get_data['icon_posts'];
				} else if (is_page() && (!is_home() || !is_front_page())) {
					$icon_to_dispaly = $get_data['icon_pages'];
				}
			}
		}
		if($icon_to_dispaly=="1") {
			$display_icon = 1;
		}
		$content_post = get_post(get_the_ID());
		$content = $content_post->post_content;
		if ( has_shortcode( $content, 'ig_icon_display' ) ) { 
			$display_icon = 1;
		}
		$disp_img = $get_data['ig_image_url'];
		if($disp_img == ''){
			$disp_img = $this->plugin_url.'/pages/images/icon_left.png';
		}
		if($display_icon==1){
			$ig_image_width = 50;
			$ig_image_height = 50;
			$ig_image_height_small = 50;
			$ig_image_width_small = 50;
			if($get_data['ig_image_width'] > 0){
				$ig_image_width = $get_data['ig_image_width'];
			}
			if($get_data['ig_image_height'] > 0){
				$ig_image_height = $get_data['ig_image_height'];
			}
			if($get_data['ig_image_width_small'] > 0){
				$ig_image_width_small = $get_data['ig_image_width_small'];
			}
			if($get_data['ig_image_height_small'] > 0){
				$ig_image_height_small = $get_data['ig_image_height_small'];
			}
			if($get_data['icon_opacity']){
				if($get_data['icon_opacity'] == '10'){
					$icon_opacity = '1;';
				}else{
					$icon_opacity = '0.'.$get_data['icon_opacity'].';';
				}			
			}else{
				$icon_opacity = '1;';
			}
			if($get_data['icon_position_lr'] == 'r'){
				$position_lr = 'right:0;';
			}else{
				$position_lr = 'left:0;';
			}
			if($get_data['icon_position_tb']){
				$position_tb = 'top:'.$get_data['icon_position_tb'].'%;';
			}else{
				$position_tb= 'top:40%';
			}
			// echo $to_add = '<img src="'.$disp_img.'" onclick="ig_modal_open("'.$vertical_position.'","'.$horizontal_position.'");" class="ig_img_hand" style="width:'.$ig_image_width.'px; height:'.$ig_image_height.'px;opacity:'.$icon_opacity.$position_lr.$position_tb.';" />';
			echo '<style>';
			echo ".ig_img_hand{width:".$ig_image_width."px;height:".$ig_image_height."px;}";
			echo "@media screen and (max-width: 1023px) {.ig_img_hand{width:".$ig_image_width_small."px;height:".$ig_image_height_small."px;}}";
			echo '</style>';
			$argues = "'".$vertical_position."',"."'".$horizontal_position."'";
			$argues = 'onclick="ig_modal_open('.$argues.');"';
			echo $to_add = "<img src='$disp_img' $argues class='ig_img_hand' style='opacity:".$icon_opacity.$position_lr.$position_tb."'/>";
		}
		if($_GET['runcron'] == 'Y'){
			echo ig_cron_code();
			//echo do_shortcode("[recommended_products]");
		}
		if($_GET['manage_subscription'] == 'Y'){
			echo '<script type="text/javascript">modal_open_subscription();</script>';
		}
	}
	function add_header(){
		echo "<script type='text/javascript'>var myEvent = window.attachEvent || window.addEventListener;
		var chkevent = window.attachEvent ? 'onbeforeunload' : 'beforeunload'; /// make IE7, IE8 compatable

		myEvent(chkevent, function(e) { // For >=IE7, Chrome, Firefox
			var confirmationMessage = ' ';  // a space
			(e || window.event).returnValue = confirmationMessage;
			return confirmationMessage;
		});</script>";
	}
	//function add_to_content($content)
	
	function add_to_content() {
		$region_options = array(
			"com" => array("label" =>  "United States"),
			"co.uk" => array("label" => "United Kingdom"),
			"ca" => array("label" => "Canada"),
			"cn" => array("label" => "China"),
			"fr" => array("label" => "France"),
			"de" => array("label" => "Germany"),
			"in" => array("label" => "India"),
			"it" => array("label" => "Italy"),		    
			"co.jp" => array("label" => "Japan"),
			"es" => array("label" => "Spain")			
		);
		/*
			"com" => array("label" =>  "United States"),
			"co.uk" => array("label" => "United Kingdom"),
			"com.au" => array("label" => "Australia"),
			"ca" => array("label" => "Canada"),
			"com.mx" => array("label" => "Mexico"),
			"nl" => array("label" => "Netherlands"),
			"com.br" => array("label" => "Brazil"),
			"cn" => array("label" => "China"),
			"fr" => array("label" => "France"),
			"de" => array("label" => "Germany"),
			"in" => array("label" => "India"),
			"it" => array("label" => "Italy"),		    
			"co.jp" => array("label" => "Japan"),
			"es" => array("label" => "Spain")
		*/
		$get_data = stripslashes_deep(get_option('InstaGenius-AdminOptions'));
		$ig_search_keywords = stripslashes_deep(get_option('ig_search_keywords'));	
		$ig_searchbtn_color = '#fc5b5b';
		$ig_searchbtn_color = $get_data['ig_searchbtn_color']=='' ? $ig_searchbtn_color : $get_data['ig_searchbtn_color'];		
		$green_not_text = 'Now is a great time to buy';
		$yellow_not_text = "We don't have enough data yet";
		$red_not_text = 'You might want to wait before you buy';
		$green_not_text = $get_data['green_not_text']=='' ? $green_not_text : $get_data['green_not_text'];
		$yellow_not_text = $get_data['yellow_not_text']=='' ? $yellow_not_text : $get_data['yellow_not_text'];
		$red_not_text = $get_data['red_not_text']=='' ? $red_not_text : $get_data['red_not_text'];
		$ig_logo_image_url = $get_data['ig_logo_image_url'];
		if($ig_logo_image_url == ''){
			$ig_logo_image_url = $this->plugin_url.'/pages/images/iglogo.png';
		}
		
		
		$modal = '
		<div id="modal_preview" class="ig-demo-modal">
			<div class="popup_header" class="ig_padtop_1per">				
				<div class="ig_full_width">
				<div class="ig_left_header ig_fleft">
					<form name="amazon_form" id="amazon_form" method="POST" onkeypress="return event.keyCode != 13;">
					<input type="hidden" name="action" value="ig_get_amazon_products" />
					<img class="ig_logo" src="'.$ig_logo_image_url.'">
					<select name="ig_popup_region" id="ig_popup_region" class="input_ig_popup_region">';
						foreach ($get_data['amzregion'] as $areg){
							$modal .= '<option value="'.$areg.'">'.$region_options[$areg]['label'].'</option>';
						}
					$modal .= '</select>
					<input placeholder="Search..." type="text" name="amazon_keyword" id="amazon_keyword" class="input_ig_amazon_keyword" />
					<button type="button" onclick="submit_popup();" class="ig_search_btn" style="background-color: '.$ig_searchbtn_color.';"><img src="'.$this->plugin_url.'/includes/images/ig_icon/search.png" class="ig_search_img" /></button>';
					
				$modal .= '</form></div>
				<div class="ig_right_header ig_fright">
					<div class="ig_right_header_box">
						<strong class="ig_heading">Save up to 75%+ with our best deal member tool.</strong>
						<strong class="ig_heading_normal">Search for low prices & our smart buyer advice.</strong>
						<div class="ig_pad_1per">
							<ul class="ig_ul_liststyle_none">
								<li>
									<img src="'.$this->plugin_url.'/includes/images/ig_icon/green.png" />'.$green_not_text.'
								</li>
								<li>
									<img src="'.$this->plugin_url.'/includes/images/ig_icon/yellow.png" />'.$yellow_not_text.'
								</li>
								<li>
									<img src="'.$this->plugin_url.'/includes/images/ig_icon/red.png" />'.$red_not_text.'
								</li>
							</ul>
						</div>
					</div>
				</div>
				</div>
				
				<div class="ig_fclear"></div>
			</div>
			<div class="ig_popup_content">
				<span class="ig_recent_search_heading">Recent searches:</span>
				<ul class="ig_ul_liststyle_none">';
				if($get_data['approved_keyword_rand'] == 'rand'){
					$ig_search_keywords_arr = explode("||", $ig_search_keywords);
					$ig_search_keywords_arr_unique = array_unique(array_filter(array_reverse($ig_search_keywords_arr)));
					$ig_search_keywords_arr_unique = array_values($ig_search_keywords_arr_unique);
					$n = sizeof($ig_search_keywords_arr_unique);
					if($n > 10){
						$n = 10;
					}
					for($i=0; $i<$n; $i++){
						$modal .= '<li><a class="tag-left">&nbsp; &nbsp; </a><a href="javascript:void(0);" onclick="tag_search('."'".$ig_search_keywords_arr_unique[$i]."'".')" class="tag-text">'.$ig_search_keywords_arr_unique[$i].'</a></li>';
					}
				}else if(count($get_data['approved_keywords']) > 0){
					$ig_search_keywords_arr_unique = array_values($get_data['approved_keywords']);
					$n = sizeof($ig_search_keywords_arr_unique);
					if($n > 10){
						$n = 10;
					}
					for($i=0; $i<$n; $i++){
						$modal .= '<li><a class="tag-left">&nbsp; &nbsp; </a><a href="javascript:void(0);" onclick="tag_search('."'".$ig_search_keywords_arr_unique[$i]."'".')" class="tag-text">'.$ig_search_keywords_arr_unique[$i].'</a></li>';
					}
				}
				$modal .= '
				</ul>
			</div>
			<!--<button type="button" onclick="submit_popup();">Search Products</button>-->
			<div id="ig_result_div_response" class="ig_amazon_productsbox"></div>
			<div id="loader_div"><img src="'.$this->plugin_url.'/pages/images/loading.gif" /></div>
			<div align="center" class="more_div">
				<button id="load_more_button" onclick="amazon_loadmore();" data="1" type="button">Click Here To Load More Special Offers</button>
			</div>
		</div>';
		
		$modal_manage_subscription = '<div id="modal_manage_subscription" class="ig-demo-modal ig_demo-modal-width-40">
			<div class="popup_header ig_padtop_1per">
				<div class="ig_full_width">
					
					<img class="ig_logo" src="'.$this->plugin_url.'/pages/images/iglogo.png">
					<br><br>
					<div class="subscription_msg" style="display:none;">your subscriptions updated.</div>
					<div class="ig_manage_subscription">';
					if(is_user_logged_in()){
						//$modal_manage_subscription .= 'List of products user subscribed...';
						$modal_manage_subscription .= get_subscribed_products(get_current_user_id());
					}else{
						$modal_manage_subscription .= 'Please <a href="'.wp_login_url( site_url() .'/?'. $_SERVER["QUERY_STRING"] ).'">login</a>';
					}
					
					$modal_manage_subscription .= '</div>
				</div></div>	
				</div>';
		//return $content.$modal.$modal_manage_subscription;
		echo $modal.$modal_manage_subscription;
		
	}
	function ig_hideicon_meta_add(){
		add_meta_box( 'ig-hideicon-meta-id', 'InstaGenius Hide Icon', array($this,'ig_hideicon_meta'), '', 'side', 'low' );
	}
	function ig_hideicon_meta(){
		global $post;
		$values = get_post_meta( $post->ID, 'ig_hide_icon_check', true  );
		wp_nonce_field( 'my_meta_box_nonce', 'meta_box_nonce' );
		?>
		<p>
			<input type="checkbox" id="ig_hide_icon_check" name="ig_hide_icon_check" <?php checked( $values, '1' ); ?> />
			<label for="ig_hide_icon_check">Check to Hide InstaGenius Icon on Page/Post.</label>
		</p>
		<?php    
	}
	function cd_meta_box_save( $post_id ){
		$chk = isset( $_POST['ig_hide_icon_check'] ) ? '1' : '0';
		update_post_meta( $post_id, 'ig_hide_icon_check', $chk );
	}
	
	function get_update_info($transient) {
		$runfile = "http://ipn.wfcguard.com/ig-update.php";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $runfile);
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		$plugin = curl_exec ($ch);
		curl_close ($ch); 
		$plugin = json_decode($plugin);
		$new_url = $plugin->url;
		$new_ver = $plugin->version;
		$tested = $plugin->tested_upto;
		$cur_ver = IG_VERSION;
		if (version_compare($cur_ver, $new_ver, 'lt')) {
			$plugin = new stdClass();
			$plugin->slug = IG_FOLDER;
			$plugin->plugin = IG_FOLDER.'/insta-genius.php';
			$plugin->new_version = $new_ver;
			$plugin->package = $new_url;
			$plugin->tested = $tested;
			$plugin->url='https://wildfireconcepts.com';
			$transient->response[IG_FOLDER.'/insta-genius.php'] = $plugin;
		}
		return $transient;
	}

}
/*Class End*/
/*
function ig_cron_schedule( $schedules ) {
 
    $schedules['every_five_minutes'] = array(
            'interval'  => 300,
            'display'   => __( 'Every 30 Minutes' )
    );
     
    return $schedules;
}
add_filter( 'cron_schedules', 'ig_cron_schedule' );
if(!wp_next_scheduled('cron_hook')){
	wp_schedule_event(time(),'every_five_minutes','cron_hook');
}

add_action( 'cron_hook', 'ig_cron_code' );
*/
function get_subscribed_products($user_id){
	global $wpdb;
	require_once "includes/Amazon-ECS-PHP-Library-master/lib/AmazonECS.class.php";
	$options = stripslashes_deep(get_option('InstaGenius-AdminOptions'));
	$tb_name=$wpdb->prefix.'ig_subscribed_products';
	
	$str_subscribed_prods = '';
	$subscribed_products = $wpdb->get_results("SELECT region, id, asin FROM $tb_name where user_id = ".$user_id." order by rand()");
	if($subscribed_products){
		$str_subscribed_prods .= '<form name="frm_manage_subscription" id="frm_manage_subscription" method="POST"><input type="hidden" name="input_action" id="input_action" value="ig_update_user_subscription" /><input type="hidden" name="ms_user_id" id="ms_user_id" value="'.$user_id.'" />';
		foreach($subscribed_products as $subscribed_products){
			if($prod_region != $subscribed_products->region){
				$prod_region = $subscribed_products->region;			
				//$str_subscribed_prods .= '--'.$prod_region.'--';
				$key_amazon = array_search($subscribed_products->region,$options['amzregion']);
				$associate = $options['amzaffid'][$key_amazon];
				$access_key = $options['amzpubkey'][$key_amazon];
				$secret_key = $options['amzprikey'][$key_amazon];
				$country = $options['amzregion'][$key_amazon];
				$amazonEcs = new AmazonECS($access_key,$secret_key,$country,$associate);
				//$amazonEcs->category('All');
				$amazonEcs->responseGroup('Small');
				$amazonEcs->returnType(AmazonECS::RETURN_TYPE_ARRAY);
				$amazonEcs->page(1);
			}
			$subscribed_prod_details = $amazonEcs->lookup($subscribed_products->asin);
			//print_r($subscribed_prod_details);
			//$str_subscribed_prods .= '<div style="float:left; width: 20%;"><a href="'.$subscribed_prod_details['Items']['Item']['DetailPageURL'].'" target="_blank"><img src="'.$subscribed_prod_details['Items']['Item']['LargeImage']['URL'].'" width="90" /></a></div><div style="float:left; width: 50%;">'.$subscribed_prod_details['Items']['Item']['ItemAttributes']['Title'].'</div><div style="float: left; width: 30%;">Price: '.$subscribed_prod_details['Items']['Item']['ItemAttributes']['ListPrice']['FormattedPrice'].'</div><div style="width: 5%; float:right;"><input type="checkbox" name="is_subscribed['.$subscribed_products->id.']" /></div><div style="clear:both;"></div>';
			
			$str_subscribed_prods .= '<div style="float:left; width: 90%;">'.$subscribed_prod_details['Items']['Item']['ItemAttributes']['Title'].'</div><div style="width: 10%; float:right;"><input type="checkbox" checked="checked" name="is_subscribed['.$subscribed_products->id.']" class="ig_fright ig_checkbox" value="'.$subscribed_products->id.'" /></div><div style="clear:both;"></div>';
			sleep(1);
		}
		$str_subscribed_prods .= '<br /><button onclick="manage_subscriptions('.$user_id.');" class="ig_btn_subscribe ig_fright" type="button">Update Subscription</button><img id="loader_div" src="'.plugins_url(basename( dirname( __FILE__))).'/pages/images/loading.gif" style="float: right; height: 35px;" /></form>';
	}else{
		$str_subscribed_prods='No subscriptions available.';		
	}
	
	$str_subscribed_prods .= '<br /><br /><hr /><center><button onclick="close_open_modal();" class="ig_btn_subscribe" type="button">Or Click Here To Add New Items To Your Watch List</button></center><br />';
		
	return $str_subscribed_prods;
	
	/*
	
	if($subscribed_products){
		$str_subscribed_prods .= '<div style="clear:both; width: 100%; ">';
		foreach($subscribed_products as $subscribed_products){
			$key_amazon = array_search($subscribed_products->region,$options['amzregion']);
			$associate = $options['amzaffid'][$key_amazon];
			$access_key = $options['amzpubkey'][$key_amazon];
			$secret_key = $options['amzprikey'][$key_amazon];
			$country = $options['amzregion'][$key_amazon];
			$amazonEcs = new AmazonECS($access_key,$secret_key,$country,$associate);
			$amazonEcs->category('All');
			$amazonEcs->responseGroup('Large');
			$amazonEcs->returnType(AmazonECS::RETURN_TYPE_ARRAY);
			$amazonEcs->page(1)
			$subscribed_prod_details = $amazonEcs->lookup($subscribed_products->asin);
			
			$str_subscribed_prods .= '<div style="float:left; width: 30%: margin: 1%"><a href="'.$subscribed_prod_details['Items']['Item']['DetailPageURL'].'" target="_blank"><img src="'.$subscribed_prod_details['Items']['Item']['LargeImage']['URL'].'" width="90" /></a><br>'.$subscribed_prod_details['Items']['Item']['ItemAttributes']['Title'].'<br>Price: '.$subscribed_prod_details['Items']['Item']['ItemAttributes']['ListPrice']['FormattedPrice'].'</div>';
			
		}
		$str_subscribed_prods .= '</div><div style="clear:both;"></div>';
	}else{
		$str_subscribed_prods .= 'Not Subscribed for any other products!!!';
	}
	
	return $str_subscribed_prods;
	*/
}

function ig_cron_code(){
	//wp_mail( 'setc.avesh@gmail.com', 'Automatic email 2 Days', 'Automatic scheduled email from WordPress.');
	global $wpdb;
	//echo 'cron function';
	$adminusers = get_userdata(1);
	$admin_name=$adminusers->user_login;
	$site_title = get_bloginfo( 'name' );					
	require_once "includes/Amazon-ECS-PHP-Library-master/lib/AmazonECS.class.php";
	$options = stripslashes_deep(get_option('InstaGenius-AdminOptions'));
	$tb_name=$wpdb->prefix.'ig_subscribed_products';
	$retrieve_data = $wpdb->get_results( "SELECT * FROM $tb_name");
	
	if($retrieve_data){
		//get email templates values - start
		$tpl_name=$wpdb->prefix.'ig_email_template';
		$template_data = $wpdb->get_results( "SELECT * FROM $tpl_name");
		if($template_data){
			$email_templates = array();
			foreach($template_data as $templates){
				$email_templates[$templates->template_val] = $templates;
			}			
		}
		//get email templates values - end
		foreach($retrieve_data as $subscribed){
			$user_id=$subscribed->user_id;
			$user_name="";
			$user_email="";
			$user_info=get_userdata($user_id);
			$first_name=$user_info->first_name;
			$last_name=$user_info->last_name;
			$user_email=$user_info->user_email;
			if($first_name || $last_name){
				$user_name=$first_name.' '.$last_name;
			}else{
				$user_name=$user_info->user_login;
			}	
					
			$key_amazon = array_search($subscribed->region,$options['amzregion']);
			$associate = $options['amzaffid'][$key_amazon];
			$access_key = $options['amzpubkey'][$key_amazon];
			$secret_key = $options['amzprikey'][$key_amazon];
			$country = $options['amzregion'][$key_amazon];
			$amazonEcs = new AmazonECS($access_key,$secret_key,$country,$associate);
			$amazonEcs->category('All');
			$amazonEcs->responseGroup('Large');
			$amazonEcs->returnType(AmazonECS::RETURN_TYPE_ARRAY);
			$amazonEcs->page(1);
			//$response_final = $amazonEcs->getAmazonPrice('com', $asin);
			$response_final = $amazonEcs->lookup($subscribed->asin);
			
			$current_price=$response_final['Items']['Item']['ItemAttributes']['ListPrice']['Amount'];
			$item_link=$response_final['Items']['Item']['DetailPageURL'];
			$item_name=$response_final['Items']['Item']['ItemAttributes']['Title'];
			//$current_price='4100';
			
			//subscribed products - start
			if($options['total_sp'] > 0){
				$total_sp = $options['total_sp'];
			}else{
				$total_sp = 3;
			}
			$str_subscribed_prods = '';
			$subscribed_products = $wpdb->get_results( "SELECT * FROM $tb_name where user_id = ".$subscribed->user_id." order by rand() limit $total_sp");
			if($subscribed_products){
				$str_subscribed_prods .= '<div style="clear:both; width: 100%; ">';
				foreach($subscribed_products as $subscribed_products){
					$subscribed_prod_details = $amazonEcs->lookup($subscribed->asin);
					
					$str_subscribed_prods .= '<div style="float:left; width: 30%: margin: 1%"><a href="'.$subscribed_prod_details['Items']['Item']['DetailPageURL'].'" target="_blank"><img src="'.$subscribed_prod_details['Items']['Item']['LargeImage']['URL'].'" width="90" /></a><br>'.$subscribed_prod_details['Items']['Item']['ItemAttributes']['Title'].'<br>Price: '.$subscribed_prod_details['Items']['Item']['ItemAttributes']['ListPrice']['FormattedPrice'].'</div>';
					
				}
				$str_subscribed_prods .= '</div><div style="clear:both;"></div>';
			}else{
				$str_subscribed_prods .= 'Not Subscribed for any other products!!!';
			}			
			//subscribed products - end			
			
			//recommended products - start
			$response_recommended = $amazonEcs->similarityLookup($subscribed->asin);
			//print_r($response_recommended);
			//$recommended_products = $response_final['Items']['Item']['SimilarProducts']['SimilarProduct'];
			$recommended_products = $response_recommended['Items']['Item'];
			if($options['total_rp'] > 0){
				$total_rp = $options['total_rp'];
			}else{
				$total_rp = 3;
			}			
			$str_recommended_prods = '<div style="clear:both; width: 100%; ">';
			for($rp=0; $rp<$total_rp; $rp++){
				//$asin =$singleItem['ASIN'];
				$str_recommended_prods .= '<div style="float:left; width: 30%: margin: 1%"><a href="'.$recommended_products[$rp]['DetailPageURL'].'" target="_blank"><img src="'.$recommended_products[$rp]['LargeImage']['URL'].'" width="90" /></a><br>'.$recommended_products[$rp]['ItemAttributes']['Title'].'<br>Price: '.$recommended_products[$rp]['OfferSummary']['LowestNewPrice']['FormattedPrice'].'</div>';
			}
			$str_recommended_prods .= '</div><div style="clear:both;"></div>';
			
			/*
			foreach($recommended_products as $recommended_products){
				$str_recommended_prods .= '<a href="https://www.amazon.com/gp/product/'.$recommended_products['ASIN'].'">'.$recommended_products['Title'].'<br>';
			}
			*/			
			//recommended products - end
			
			//subscribed products - start
			if($options['total_sp'] > 0){
				$total_sp = $options['total_sp'];
			}else{
				$total_sp = 3;
			}			
			$subscriber_id = $subscribed->user_id; //subscriber
			//get all subscribed products list of this user...
			//subscribed products - end
			$str_manage_subscriptions = '<a href="'.site_url().'/?manage_subscription=Y" target="_blank">Manage Subscriptions</a>';
			$email_template_find_array = array('[admin_username]', '[site_name]', '[subscriber_name]', '[product_link]', '[product_name]', '[recommended_products]', '[subscribed_products]','[manage_subscriptions]');
			$email_template_replace_array = array($admin_name, $site_title, $user_name, $item_link, $item_name, $str_recommended_prods, $str_subscribed_prods,$str_manage_subscriptions);
			
			/* price drop email - start */
			
			if($current_price && $subscribed->price){
				if($current_price<$subscribed->price){
					
					//price drop mail
					$body_msg=$email_templates['price_drop']->template_body;					
					$body_msg=str_replace($email_template_find_array,$email_template_replace_array,$body_msg);
					$subject=$email_templates['price_drop']->template_subject;
					$subject=str_replace($email_template_find_array,$email_template_replace_array,$subject);
					if(wp_mail($user_email,$subject,$body_msg,array('MIME-Version: 1.0','Content-type: text/html; charset=iso-8859-1'))){
						//update price after email sent once...
						$price_drop_date = date('Y-m-d h:i:s');
						$update_query = "update $tb_name set price=$current_price, price_drop_date='".$price_drop_date."', is_followup_1day = 0, is_followup_7day = 0, is_recommended_14day = 0, is_recommended_7day = 0, is_subscriber_30day = 0 where id='".$subscribed->id."'";
						$wpdb->query($update_query);
					}
					//price drop mail - end
					
				}		
			}
			/* price drop email - end */
			
			
			$today_date = date("Y-m-d H:i:s");
			if($subscribed->price_drop_date > 0){
				/* other mails if price drops - start */
				$price_drop_date = strtotime($subscribed->price_drop_date);
				
				if($subscribed->is_followup_1day == 0){ //follow up 1 day
					$nextdaydate = $price_drop_date + (24*60*60);
					$date_after_1day = date("Y-m-d H:i:s", $nextdaydate);
					if($today_date > $date_after_1day){
						//send followup 1day mail - start
						$body_msg=$email_templates['followup_1day']->template_body;					
						$body_msg=str_replace($email_template_find_array,$email_template_replace_array,$body_msg);
						$subject=$email_templates['followup_1day']->template_subject;
						$subject=str_replace($email_template_find_array,$email_template_replace_array,$subject);
						if(wp_mail($user_email,$subject,$body_msg,array('MIME-Version: 1.0','Content-type: text/html; charset=iso-8859-1'))){
							//update price after email sent once...
							$update_query = "update $tb_name set is_followup_1day = 1 where id='".$subscribed->id."'";
							$wpdb->query($update_query);
						}
						//send followup 1day mail - end
						
					}
				}else if($subscribed->is_followup_7day == 0){ //follow up 7 day
					$nextdaydate = $price_drop_date + (7*24*60*60);
					$date_after_7day = date("Y-m-d H:i:s", $nextdaydate);
					if($today_date > $date_after_7day){
						//send followup 7day mail - start
						$body_msg=$email_templates['followup_7day']->template_body;					
						$body_msg=str_replace($email_template_find_array,$email_template_replace_array,$body_msg);
						$subject=$email_templates['followup_7day']->template_subject;
						$subject=str_replace($email_template_find_array,$email_template_replace_array,$subject);
						if(wp_mail($user_email,$subject,$body_msg,array('MIME-Version: 1.0','Content-type: text/html; charset=iso-8859-1'))){
							//update price after email sent once...
							$update_query = "update $tb_name set is_followup_7day = 1 where id='".$subscribed->id."'";
							$wpdb->query($update_query);
						}
						//send followup 7day mail - end	
					}
				}else if($subscribed->is_recommended_14day == 0){ // Recommended 14 days
					$nextdaydate = $price_drop_date + (14*24*60*60);
					$date_after_14day = date("Y-m-d H:i:s", $nextdaydate);
					if($today_date > $date_after_14day){
						//send recommended 14day mail - start
						$body_msg=$email_templates['recommended_14day']->template_body;					
						$body_msg=str_replace($email_template_find_array,$email_template_replace_array,$body_msg);
						$subject=$email_templates['recommended_14day']->template_subject;
						$subject=str_replace($email_template_find_array,$email_template_replace_array,$subject);
						if(wp_mail($user_email,$subject,$body_msg,array('MIME-Version: 1.0','Content-type: text/html; charset=iso-8859-1'))){
							//update price after email sent once...
							$update_query = "update $tb_name set is_recommended_14day = 1 where id='".$subscribed->id."'";
							$wpdb->query($update_query);
						}
						//send recommended 14day mail - end						
					}
				}
				/* other mails if price drops - end */
			}else{
				// 7 days after subscribe - if no price drop
				if($subscribed->is_recommended_7day == 0){ //follow up 7 day
					$nextdaydate = strtotime($subscribed->timestamp) + (7*24*60*60);
					$date_after_7day = date("Y-m-d H:i:s", $nextdaydate);
					if($today_date > $date_after_7day){
						//send followup 7day mail - start
						$body_msg=$email_templates['recommended_7day']->template_body;					
						$body_msg=str_replace($email_template_find_array,$email_template_replace_array,$body_msg);
						$subject=$email_templates['recommended_7day']->template_subject;
						$subject=str_replace($email_template_find_array,$email_template_replace_array,$subject);
						if(wp_mail($user_email,$subject,$body_msg,array('MIME-Version: 1.0','Content-type: text/html; charset=iso-8859-1'))){
							//update price after email sent once...
							$update_query = "update $tb_name set is_recommended_7day = 1 where id='".$subscribed->id."'";
							$wpdb->query($update_query);
						}
						//send followup 7day mail - end
					}
				}
			}
			
			// price drop or not - every 30 days after user subscribe
			if($subscribed->subscription_mail_sentdate > 0){
				$last_sent_date = $subscribed->subscription_mail_sentdate;
			}else{
				$last_sent_date = $subscribed->timestamp;
			}
			$nextmonthdate = strtotime($last_sent_date) + (30*24*60*60);
			$date_after_1month = date("Y-m-d H:i:s", $nextmonthdate);
			if($today_date > $date_after_1month){
				//send subscription every 30day mail - start
				$body_msg=$email_templates['subscriber_30day']->template_body;					
				$body_msg=str_replace($email_template_find_array,$email_template_replace_array,$body_msg);
				$subject=$email_templates['subscriber_30day']->template_subject;
				$subject=str_replace($email_template_find_array,$email_template_replace_array,$subject);
				if(wp_mail($user_email,$subject,$body_msg,array('MIME-Version: 1.0','Content-type: text/html; charset=iso-8859-1'))){
					$update_query = "update $tb_name set subscription_mail_sentdate = '".$today_date."' where id='".$subscribed->id."'";
					$wpdb->query($update_query);
				}
				//send subscription every 30day mail - end				
			}
			
	
		}
		
	}	
	
	
	
}
/*
* AJAX Functions
*/
add_action('wp_ajax_nopriv_ig_login_checker', 'ig_login_checker');
add_action('wp_ajax_ig_login_checker', 'ig_login_checker');
add_action('wp_ajax_nopriv_ig_get_amazon_products', 'ig_get_amazon_products');
add_action('wp_ajax_ig_get_amazon_products', 'ig_get_amazon_products');
add_action('wp_ajax_nopriv_ig_amazon_subscribe_products', 'ig_amazon_subscribe_products');
add_action('wp_ajax_ig_amazon_subscribe_products', 'ig_amazon_subscribe_products');
add_action('wp_ajax_ig_update_user_subscription','ig_update_user_subscription');
add_action('wp_ajax_nopriv_ig_update_user_subscription','ig_update_user_subscription');
add_action('wp_ajax_is_user_logged_in', 'ajax_check_user_logged_in');
add_action('wp_ajax_nopriv_is_user_logged_in', 'ajax_check_user_logged_in');
add_action('wp_ajax_add_to_cart_counter', 'add_to_cart_counter');
add_action('wp_ajax_nopriv_add_to_cart_counter', 'add_to_cart_counter');
add_action('wp_ajax_watchlist_counter', 'watchlist_counter');
add_action('wp_ajax_nopriv_watchlist_counter', 'watchlist_counter');
function add_to_cart_counter(){
	$counter = get_option('igen_add_to_cart_counter');
	if(empty($counter)){
		$counter = 0;
	}
	$counter++;
	update_option('igen_add_to_cart_counter',$counter);
	die();
}
function watchlist_counter(){
	$counter = get_option('igen_add_to_watchlist_counter');
	if(empty($counter)){
		$counter = 0;
	}
	$counter++;
	update_option('igen_add_to_watchlist_counter',$counter);
	die();
}
function ajax_check_user_logged_in() {
    echo is_user_logged_in()?'yes':'no';
    die();
}
function ig_login_checker(){
	if($_POST){
		global $wpdb;
		$username = $wpdb->escape($_REQUEST['loginu']);
		$password = $wpdb->escape($_REQUEST['loginp']);
		$login_data = array();
		$login_data['user_login'] = $username;
		$login_data['user_password'] = $password;
		$user_verify = wp_signon( $login_data, false ); 
		if ( is_wp_error($user_verify) ){
		   echo 'Problem Signing In';
		}else{	
		   echo "success";
		}
	}else{
		echo "Invalid login details";
	}
	die();
}
function ig_get_amazon_products(){
	global $wpdb;
	require_once "includes/Amazon-ECS-PHP-Library-master/lib/AmazonECS.class.php";
	
	$amazon_region = $_POST['amazon_region'];
	$amazon_keyword = $_POST['amazon_keyword'];
	
	$InstaGenius = new IG_InstaGenius();
	
	if($amazon_keyword != ''){
		$ig_search_keywords = stripslashes_deep(get_option('ig_search_keywords'));
		//save search keyword - start
		update_option('ig_search_keywords',$ig_search_keywords.'||'.$amazon_keyword);
		//save search keyword - end
	}
	
	$options = stripslashes_deep(get_option('InstaGenius-AdminOptions'));
	// echo get_option('license_key_valid_once');exit;
	if(get_option('license_key_valid_once')){
		$display_type = $options['pro_feature_display_option'];
	}else{
		$display_type = 0;
	}
	$show_amazon = 0;
	$show_ig_prod = 0;
	if($display_type == 0){
		$key_amazon = array_search($amazon_region,$options['amzregion']);
		$associate = $options['amzaffid'][$key_amazon];
		$access_key = $options['amzpubkey'][$key_amazon];
		$secret_key = $options['amzprikey'][$key_amazon];
		$country = $options['amzregion'][$key_amazon];
		$amazonEcs = new AmazonECS($access_key,$secret_key,$country,$associate);
		// echo $amazonEcs;exit;
		for($i=1;$i<=2;$i++){
			$amazonEcs->category('All');
			$amazonEcs->responseGroup('Large');
			$amazonEcs->returnType(AmazonECS::RETURN_TYPE_ARRAY);
			$amazonEcs->page($i);
			$response_final[] = $amazonEcs->search($amazon_keyword);
		}
		$show_amazon = 1;
	}else if($display_type == 1){
		$query_prod = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."ig_store_products` WHERE `prod_name` LIKE '%$amazon_keyword%'");
		$show_ig_prod = 1;
	}
	/*}else if($display_type == 1){
		$query_prod = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."ig_store_products`");
		foreach($query_prod as $qp){
			$title = $qp['prod_name'];
			$image = $qp['prod_image'];
			$price = $qp['prod_price'];
			$price = $qp['prod_price'];
		}
		echo '<pre>';
		print_r($response_final);
		echo '</pre>';exit;
	}*/
	/*foreach($response_final as $rs){
		echo '<pre>';
	print_r($rs);echo '</pre>';exit;
	}*/
	

	$green_not_text = 'Now is a great time to buy';
	$yellow_not_text = "We don't have enough data yet";
	$red_not_text = 'You might want to wait before you buy';
	$green_not_text = $options['green_not_text']=='' ? $green_not_text : $options['green_not_text'];
	$yellow_not_text = $options['yellow_not_text']=='' ? $yellow_not_text : $options['yellow_not_text'];
	$red_not_text = $options['red_not_text']=='' ? $red_not_text : $options['red_not_text'];
	
	$ig_button_color = '#fc5b5b';
	$ig_button_color = $options['ig_button_color']=='' ? $ig_button_color : $options['ig_button_color'];
	$ig_price_color = '#fc5b5b';
	$ig_price_color = $options['ig_price_color']=='' ? $ig_price_color : $options['ig_price_color'];
	
	
	$array_nottext = array();
	$array_nottext['green'] = array();
	$array_nottext['green']['text'] = $green_not_text;
	$array_nottext['green']['image'] = 'green_not.png';
	$array_nottext['yellow'] = array();
	$array_nottext['yellow']['text'] = $yellow_not_text;
	$array_nottext['yellow']['image'] = 'yellow_not.png';
	$array_nottext['red'] = array();
	$array_nottext['red']['text'] = $red_not_text;
	$array_nottext['red']['image'] = 'red_not.png';
	$plugin = $InstaGenius->plugin_url;
	$i = 1;
	$action = 'ig_amazon_subscribe_products';
	$adBlock_start = '<div class="product_div">';
	$second_row_amazon_start = '<div id="second_row_amazon" class="row">';
	$third_row_amazon_start = '<div id="third_row_amazon" class="row">';
	$fourth_row_amazon_start = '<div id="fourth_row_amazon" class="row">';
	$fifth_row_amazon_start = '<div id="fifth_row_amazon" class="row">';
	$sixth_row_amazon_start = '<div id="sixth_row_amazon" class="row">';
	$seventh_row_amazon_start = '<div id="seventh_row_amazon" class="row">';
	if($show_amazon == 1){
	foreach($response_final as $rs){
	foreach($rs['Items']['Item'] as $singleItem){
		$rand_noti = $array_nottext[array_rand($array_nottext)];
		$img_url = 'background-image: url('.$plugin.'/includes/images/ig_icon/'.$rand_noti['image'].');';
		$asin =$singleItem['ASIN'];
		$product_title = $singleItem['ItemAttributes']['Title'];
		$image = $singleItem['LargeImage']['URL'];
		$price['price'] = $singleItem['ItemAttributes']['ListPrice']['FormattedPrice'];
		$price['amount'] = $singleItem['ItemAttributes']['ListPrice']['Amount'];
		if(empty($price['price'])){
			$price = '--';
		}
		$product_link = $singleItem['DetailPageURL'];
		$product_desc = $singleItem['EditorialReviews']['EditorialReview']['Content'];
		//if ( is_user_logged_in() ) {
		$bargain_list_action = "subscribe_product('".$amazon_region."','".$asin."','".$price['amount']."','".$action."');";
		/*}/*else if($temp_email && $temp_name){
			$bargain_list_action = "subscribe_product('".$amazon_region."','".$asin."','".$price['amount']."','".$action."');";
		}*/
		/*else{
			//$action = 'ig_amazon_subscribe_products';
			//$subscribe_new_user_action = "subscribe_user();";
			//$bargain_list_action = "modal_open_register('".$amazon_region."', '".$asin."','".$price['amount']."','".$action."');";
			$bargain_list_action = "modal_open_register('".$amazon_region."','".$asin."','".$price['amount']."','".$action."');";
		}*/
		// $postImage = '<img style="width:100%;height:auto;" src="'.$image.'" />';
		if ($i < 4){
		//$not .= "<div class='ig_prod_notification_bar'></div>";
		$content .= '<div id="ig_amazon_default" class="ig_amazon_productbox">
					<div class="ig_prod_notification_bar" style="'.$img_url.'"><span>'.$rand_noti["text"].'</span></div>
					<div class="ig_pad_2per ig_inline_block">
						<div>
							<img src="'.$image.'" width="95" class="ig_product_img" />
						</div>
						<p class="ig_product_title">'.substr($product_title,0,50).'...</p>
						<p class="ig_product_price" style="color:'.$ig_price_color.';"><span>Current Price: </span>'.$price['price'].'</p>
					</div>
					<div class="ig_pad_2per">
						<form id="add_cart_form" method="GET" target="_blank" action="http://www.amazon.'.$country.'/gp/aws/cart/add.html">
							<input type="hidden" name="AssociateTag" value="'.$associate.'"/>
							<input type="hidden" name="SubscriptionId" value="'.$access_key.'"/>
							<input type="hidden" name="ASIN.1" value="'.$asin.'"/>
							<input type="hidden" name="Quantity.1" value="1"/>
							<input type="submit" style="background: '.$ig_button_color.';" class="ig_btn_addtocart" onclick="track_add_cart();" value="Add to Cart">
						</form>';
		$content .= "<button id='subscriber_".$asin."' onclick=".$bargain_list_action." style='background: ".$ig_button_color.";' type='button' class='ig_btn_addtobargain'>Add to Bargain Watch List</button></div></div>";
		}
		if ($i >= 4 && $i < 7){
			//$not2 .= "<div class='ig_prod_notification_bar' style='".$img_url."'><span>".$rand_noti['text']."</span></div>";
			$content_loadmore_row2 .= '<div class="ig_amazon_productbox">
					<div class="ig_prod_notification_bar" style="'.$img_url.'"><span>'.$rand_noti["text"].'</span></div>
					<div class="ig_pad_2per ig_inline_block">
						<div>
							<img src="'.$image.'" width="95" class="ig_product_img" />
						</div>
						<p class="ig_product_title">'.substr($product_title,0,50).'...</p>
						<p class="ig_product_price" style="color:'.$ig_price_color.';"><span>Current Price: </span>'.$price['price'].'</p>
					</div>
					<div class="ig_pad_2per">
						<form id="add_cart_form" method="GET" target="_blank" action="http://www.amazon.'.$country.'/gp/aws/cart/add.html">
							<input type="hidden" name="AssociateTag" value="'.$associate.'"/>
							<input type="hidden" name="SubscriptionId" value="'.$access_key.'"/>
							<input type="hidden" name="ASIN.1" value="'.$asin.'"/>
							<input type="hidden" name="Quantity.1" value="1"/>
							<input type="submit" style="background: '.$ig_button_color.';" class="ig_btn_addtocart" onclick="track_add_cart();" value="Add to Cart">
						</form>';
			$content_loadmore_row2 .= "<button id='subscriber_".$asin."' onclick=".$bargain_list_action." style='background: ".$ig_button_color.";' type='button' class='ig_btn_addtobargain'>Add to Bargain Watch List</button></div></div>";
		} 
		if ($i >= 7 && $i < 10){
			//$not3 .= "<div style='".$img_url."' class='ig_prod_notification_bar'><span>".$rand_noti['text']."</span></div>";
			$content_loadmore_row3 .= '<div class="ig_amazon_productbox">
					<div class="ig_prod_notification_bar" style="'.$img_url.'"><span>'.$rand_noti["text"].'</span></div>
					<div class="ig_pad_2per ig_inline_block">
						<div>
							<img src="'.$image.'" width="95" class="ig_product_img" />
						</div>
						<p class="ig_product_title">'.substr($product_title,0,50).'...</p>
						<p class="ig_product_price" style="color:'.$ig_price_color.';"><span>Current Price: </span>'.$price['price'].'</p>
					</div>
					<div class="ig_pad_2per">
						<form id="add_cart_form" method="GET" target="_blank" action="http://www.amazon.'.$country.'/gp/aws/cart/add.html">
							<input type="hidden" name="AssociateTag" value="'.$associate.'"/>
							<input type="hidden" name="SubscriptionId" value="'.$access_key.'"/>
							<input type="hidden" name="ASIN.1" value="'.$asin.'"/>
							<input type="hidden" name="Quantity.1" value="1"/>
							<input type="submit" style="background: '.$ig_button_color.';" class="ig_btn_addtocart" onclick="track_add_cart();" value="Add to Cart">
						</form>';
			$content_loadmore_row3 .= "<button id='subscriber_".$asin."' onclick=".$bargain_list_action." style='background: ".$ig_button_color.";' type='button' class='ig_btn_addtobargain'>Add to Bargain Watch List</button></div></div>";
		}
		if ($i >= 10 && $i < 13){
			//$not4 .= "<div style='".$img_url."' class='ig_prod_notification_bar'><span>".$rand_noti['text']."</span></div>";
			$content_loadmore_row4 .= '<div class="ig_amazon_productbox">
					<div class="ig_prod_notification_bar" style="'.$img_url.'"><span>'.$rand_noti["text"].'</span></div>
					<div class="ig_pad_2per ig_inline_block">
						<div>
							<img src="'.$image.'" width="95" class="ig_product_img" />
						</div>
						<p class="ig_product_title">'.substr($product_title,0,50).'...</p>
						<p class="ig_product_price" style="color:'.$ig_price_color.';"><span>Current Price: </span>'.$price['price'].'</p>
					</div>
					<div class="ig_pad_2per">
						<form id="add_cart_form" method="GET" target="_blank" action="http://www.amazon.'.$country.'/gp/aws/cart/add.html">
							<input type="hidden" name="AssociateTag" value="'.$associate.'"/>
							<input type="hidden" name="SubscriptionId" value="'.$access_key.'"/>
							<input type="hidden" name="ASIN.1" value="'.$asin.'"/>
							<input type="hidden" name="Quantity.1" value="1"/>
							<input type="submit" style="background: '.$ig_button_color.';" class="ig_btn_addtocart" onclick="track_add_cart();" value="Add to Cart">
						</form>';
			$content_loadmore_row4 .= "<button id='subscriber_".$asin."' onclick=".$bargain_list_action." style='background: ".$ig_button_color.";' type='button' class='ig_btn_addtobargain'>Add to Bargain Watch List</button></div></div>";
		}
		if($i >= 13 && $i < 16){
			$content_loadmore_row5 .= '<div class="ig_amazon_productbox">
					<div class="ig_prod_notification_bar" style="'.$img_url.'"><span>'.$rand_noti["text"].'</span></div>
					<div class="ig_pad_2per ig_inline_block">
						<div>
							<img src="'.$image.'" width="95" class="ig_product_img" />
						</div>
						<p class="ig_product_title">'.substr($product_title,0,50).'...</p>
						<p class="ig_product_price" style="color:'.$ig_price_color.';"><span>Current Price: </span>'.$price['price'].'</p>
					</div>
					<div class="ig_pad_2per">
						<form id="add_cart_form" method="GET" target="_blank" action="http://www.amazon.'.$country.'/gp/aws/cart/add.html">
							<input type="hidden" name="AssociateTag" value="'.$associate.'"/>
							<input type="hidden" name="SubscriptionId" value="'.$access_key.'"/>
							<input type="hidden" name="ASIN.1" value="'.$asin.'"/>
							<input type="hidden" name="Quantity.1" value="1"/>
							<input type="submit" style="background: '.$ig_button_color.';" class="ig_btn_addtocart" onclick="track_add_cart();" value="Add to Cart">
						</form>';
			$content_loadmore_row5 .= "<button id='subscriber_".$asin."' onclick=".$bargain_list_action." style='background: ".$ig_button_color.";' type='button' class='ig_btn_addtobargain'>Add to Bargain Watch List</button></div></div>";
		}
		if($i >= 16 && $i < 19){
			$content_loadmore_row6 .= '<div class="ig_amazon_productbox">
					<div class="ig_prod_notification_bar" style="'.$img_url.'"><span>'.$rand_noti["text"].'</span></div>
					<div class="ig_pad_2per ig_inline_block">
						<div>
							<img src="'.$image.'" width="95" class="ig_product_img" />
						</div>
						<p class="ig_product_title">'.substr($product_title,0,50).'...</p>
						<p class="ig_product_price" style="color:'.$ig_price_color.';"><span>Current Price: </span>'.$price['price'].'</p>
					</div>
					<div class="ig_pad_2per">
						<form id="add_cart_form" method="GET" target="_blank" action="http://www.amazon.'.$country.'/gp/aws/cart/add.html">
							<input type="hidden" name="AssociateTag" value="'.$associate.'"/>
							<input type="hidden" name="SubscriptionId" value="'.$access_key.'"/>
							<input type="hidden" name="ASIN.1" value="'.$asin.'"/>
							<input type="hidden" name="Quantity.1" value="1"/>
							<input type="submit" style="background: '.$ig_button_color.';" class="ig_btn_addtocart" onclick="track_add_cart();" value="Add to Cart">
						</form>';
			$content_loadmore_row6 .= "<button id='subscriber_".$asin."' onclick=".$bargain_list_action." style='background: ".$ig_button_color.";' type='button' class='ig_btn_addtobargain'>Add to Bargain Watch List</button></div></div>";
		}
		if($i >= 19){
			$content_loadmore_row7 .= '<div class="ig_amazon_productbox">
					<div class="ig_prod_notification_bar" style="'.$img_url.'"><span>'.$rand_noti["text"].'</span></div>
					<div class="ig_pad_2per ig_inline_block">
						<div>
							<img src="'.$image.'" width="95" class="ig_product_img" />
						</div>
						<p class="ig_product_title">'.substr($product_title,0,50).'...</p>
						<p class="ig_product_price" style="color:'.$ig_price_color.';"><span>Current Price: </span>'.$price['price'].'</p>
					</div>
					<div class="ig_pad_2per">
						<form id="add_cart_form" method="GET" target="_blank" action="http://www.amazon.'.$country.'/gp/aws/cart/add.html">
							<input type="hidden" name="AssociateTag" value="'.$associate.'"/>
							<input type="hidden" name="SubscriptionId" value="'.$access_key.'"/>
							<input type="hidden" name="ASIN.1" value="'.$asin.'"/>
							<input type="hidden" name="Quantity.1" value="1"/>
							<input type="submit" style="background: '.$ig_button_color.';" class="ig_btn_addtocart" onclick="track_add_cart();" value="Add to Cart">
						</form>';
			$content_loadmore_row7 .= "<button id='subscriber_".$asin."' onclick=".$bargain_list_action." style='background: ".$ig_button_color.";' type='button' class='ig_btn_addtobargain'>Add to Bargain Watch List</button></div></div>";
		}
		$i++;
	}
	}
	$adBlock_end = '</div>';
	
	$modal_user_register = '<div id="modal_register_user" class="ig-demo-modal ig_demo-modal-width-40">			
				<form name="subscribe_form" id="subscribe_form" method="POST">
				<h4><center>'.$options[ss_headline].'</center></h4><p class="ig_ss_subheadline">'.$options[ss_subheadline].'</p>';
				if($options[ss_dispname]==1){
				$modal_user_register .= '<input type="text" name="subscriber_name" id="subscriber_name" value="" placeholder="Name" /><div id="subscriber_name_error" class="ig_red_text"></div><br />';
				}
				$modal_user_register .= '<input type="email" name="subscriber_email" id="subscriber_email" value="" placeholder="Email Address" /><div id="subscriber_email_error" class="ig_red_text"></div>
				<input type="hidden" name="input_ss_dispname" id="input_ss_dispname" value="'.$options[ss_dispname].'" />
				<input type="hidden" name="input_asin" id="input_asin" value="" />
				<input type="hidden" name="input_price" id="input_price" value="" />
				<input type="hidden" name="input_region" id="input_region" value="" />
				<input type="hidden" name="input_action" id="input_action" value="" /><br />
				<center><button onclick="subscribe_user();" class="ig_btn_subscribe" type="button">'.$options[ss_btntxt].'</button></center><br />
				<p class="ig_ss_antispam">'.$options[ss_antispam].'</p>
				<p class="ig_ss_antispam">Already a member? Please login first. <a href="javascript:void(0);" onclick="login_popup();">Click here</a></p>
				</form>';
	$modal_user_register .= '<iframe style="display:none" name="aweber-frame"></iframe>
					<form name="aweber" id="aweber_form" method="post" target="aweber-frame" action="http://www.aweber.com/scripts/addlead.pl">
						<input type="hidden" name="meta_web_form_id" value="'.get_option( 'meta_web_form_id' ).'" />
						<input type="hidden" name="meta_split_id" value="" />
						<input type="hidden" name="listname" value="'.get_option( 'listname' ).'" />
						<input type="hidden" name="redirect" value="'.site_url().'">
						<input type="hidden" name="meta_redirect_onlist" value="'.site_url().'">
						<input type="hidden" name="meta_adtracking" value="CCC_'.get_option( 'identifier' ).'" />
						<input type="hidden" name="meta_message" value="1" />
						<input type="hidden" name="meta_required" value="email" />
						<input type="hidden" name="meta_forward_vars" value="1" />
						<input type="hidden" name="meta_tooltip" value="" />
						<input type="hidden" id="ccemailid" name="email" value="" size="20">
						<input type="hidden" name="custom affid" value="'.get_option( 'ccmember_id' ).'" size="20">
					</form></div>';
	$modal_login = '<div id="modal_login" class="ig-demo-modal ig_demo-modal-width-40"><h4><center>Login</center></h4>
	<div id="success_response_change">
		<div id="success_login" style="display:none;padding-top:5%;" align="center">
			<img src="'.$InstaGenius->plugin_url.'/includes/images/ig_icon/success2.gif" />
			<br/><br/><h4>Logged In Successfully...!</h4>
		</div>
		<div id="before_login">
			<div id="ig_login_error" class="ig_red_text"></div>
			<form id="_ig_login_form" name="ig_login_form" action="'.home_url().'"/login/" method="post">
				<input type="hidden" id="ig_login_action" name="_ig_login_action" value="ig_login_checker" />
				<input id="ig_login_username" type="text" placeholder="Username" name="_ig_login_username" required><br/>
				<input id="ig_login_password" type="password" placeholder="Password" name="_ig_login_password" required><br/>
				<button onclick="_ig_login_submit();" id="ig_login_submit" class="ig_btn_subscribe" type="button">Login</button>
			</form>
		</div>
	</div>
	</div>';
	echo $adBlock_start.$not.$content.$adBlock_end.$second_row_amazon_start.$not2.$content_loadmore_row2.$adBlock_end.$third_row_amazon_start.$not3.$content_loadmore_row3.$adBlock_end.$fourth_row_amazon_start.$not4.$content_loadmore_row4.$adBlock_end.$fifth_row_amazon_start.$content_loadmore_row5.$adBlock_end.$sixth_row_amazon_start.$content_loadmore_row6.$adBlock_end.$seventh_row_amazon_start.$content_loadmore_row7.$adBlock_end.$modal_user_register.$modal_login;
	}else if($show_ig_prod == 1){
		$content_pro = '';
		foreach($query_prod as $item){
			$rand_noti = $array_nottext[array_rand($array_nottext)];
			$img_url = 'background-image: url('.$plugin.'/includes/images/ig_icon/'.$rand_noti['image'].');';
			// print_r($item['prod_image']);exit;
			$content_pro .= '<div class="product_div"><div id="ig_amazon_default" class="ig_amazon_productbox">
					<div class="ig_prod_notification_bar" style="'.$img_url.'"><span>'.$rand_noti["text"].'</span></div>
					<div class="ig_pad_2per ig_inline_block">
						<div>
							<img src="'.$item->prod_image.'" width="95" class="ig_product_img" />
						</div>
						<p class="ig_product_title" style="float:inherit">'.substr($item->prod_name,0,50).'...</p>
						<p class="ig_product_price" style="color:'.$ig_price_color.';"><span>Current Price: </span>'.$item->prod_price.'</p>
					</div>';
					
			$content_pro .=	"<a target='_blank' href='".$item->prod_url."' style='background:$ig_button_color;;text-align:center;float:inherit;' class='ig_btn_addtocart' onclick='track_add_cart();'>Add to Cart</a>";
					
			$content_pro .= '</div>';
		}
		echo $content_pro;
	}
	die();
}
function ig_amazon_subscribe_products(){
	global $wpdb;
	$cur_user = get_current_user_id();
	if(empty($cur_user)){
		$cur_user = $_COOKIE['tempuser_ig'];
	}
	
	if(isset($_POST['name']) && isset($_POST['email'])){
		//create new user
		$user_name = str_replace(" ", "_", trim($_POST['name']));
		$user_email = $_POST['email'];
		$user_id = username_exists( $user_name );
		if ( !$user_id and email_exists($user_email) == false ) {
			$random_password = wp_generate_password( $length=12, $include_standard_special_chars=false );
			$user_id = wp_create_user( $user_name, $random_password, $user_email );
		} else {
			$random_password = __('User already exists.  Password inherited.');
			$user = get_user_by( 'email', $user_email );
			$user_id = $user->ID;
		}
		$cur_user = $user_id;
		if($cur_user == 0){ echo 'Not Subscribed'; exit; }
	}
	$table_name = $wpdb->prefix."ig_subscribed_products";
	
	$asin = $_POST['asin'];
	$price = $_POST['price'];
	$region = $_POST['region'];
	$rowcount = $wpdb->get_var("SELECT COUNT(*) FROM $table_name WHERE asin='$asin' AND user_id='$cur_user'");
	if($rowcount <= 0){
		$user_info = get_userdata($cur_user);
		$name_user_ar = $user_info->user_login;
		$email_user_ar = $user_info->user_email;
		if($name_user_ar && $email_user_ar && !is_user_logged_in() && $_COOKIE['tempuser_ig'] == ''){
			check_autoresponders($email_user_ar,$name_user_ar);
		}
		if($asin){
			$user_info = get_userdata($cur_user);
			$name_user = $user_info->user_login;
			$email_user = $user_info->user_email;
			setcookie('tempuser_ig', $cur_user, time() + 30*86400, "/"); // 86400 = 1 day
			$query = 'INSERT INTO `'.$table_name.'` (asin,price,user_id,region) VALUES ("'.$asin.'","'.$price.'","'.$cur_user.'","'.$region.'")';
			if($wpdb->query($query)){
				echo 'Subscribed';
				require_once "includes/Amazon-ECS-PHP-Library-master/lib/AmazonECS.class.php";
				/*Welcome E-mail sent user to if it was first subscribe start*/
					$wpdb->get_results("SELECT * FROM $table_name WHERE user_id='$cur_user'");
					$rowcount = $wpdb->num_rows;
					if($rowcount > 0 && $rowcount < 2){
						$cc_package_information = cc_get_package_data(get_option('ccpackage_id'));
						$pack_title = $cc_package_information[0]->name;
						$pack_desc = $cc_package_information[0]->content;
						$adminusers = get_userdata(1);
						$admin_name=$adminusers->user_login;
						$site_title = get_bloginfo( 'name' );
						$tpl_name=$wpdb->prefix.'ig_email_template';
						$template_data = $wpdb->get_results( "SELECT * FROM $tpl_name");
						$options = stripslashes_deep(get_option('InstaGenius-AdminOptions'));
						if($template_data){
							$email_templates = array();
							foreach($template_data as $templates){
								$email_templates[$templates->template_val] = $templates;
							}			
							/////////////////////////
							/////////////////////////
							$key_amazon = array_search($region,$options['amzregion']);
							$associate = $options['amzaffid'][$key_amazon];
							$access_key = $options['amzpubkey'][$key_amazon];
							$secret_key = $options['amzprikey'][$key_amazon];
							$country = $options['amzregion'][$key_amazon];
							$amazonEcs = new AmazonECS($access_key,$secret_key,$country,$associate);
							$amazonEcs->category('All');
							$amazonEcs->responseGroup('Large');
							$amazonEcs->returnType(AmazonECS::RETURN_TYPE_ARRAY);
							$amazonEcs->page(1);
							//$response_final = $amazonEcs->getAmazonPrice('com', $asin);
							$response_final = $amazonEcs->lookup($asin);
							// print_r($response_final);exit;
							$current_price=$response_final['Items']['Item']['ItemAttributes']['ListPrice']['Amount'];
							$item_link=$response_final['Items']['Item']['DetailPageURL'];
							$item_name=$response_final['Items']['Item']['ItemAttributes']['Title'];
							/////////////////////////
							/////////////////////////
						$str_manage_subscriptions = '<a href="'.site_url().'/?manage_subscription=Y" target="_blank">Manage Subscriptions</a>';
						$email_template_find_array = array('[admin_username]', '[site_name]', '[subscriber_name]', '[product_link]', '[product_name]', '[recommended_products]', '[subscribed_products]','[manage_subscriptions]','[pack_title]','[pack_description]');
						$email_template_replace_array = array($admin_name, $site_title, $name_user, $item_link, $item_name, $str_recommended_prods, $str_subscribed_prods,$str_manage_subscriptions,$pack_title,$pack_desc);
						
						$body_msg=$email_templates['on_subscribe']->template_body;					
						$body_msg=str_replace($email_template_find_array,$email_template_replace_array,$body_msg);
						$subject=$email_templates['on_subscribe']->template_subject;
						$subject=str_replace($email_template_find_array,$email_template_replace_array,$subject);
						wp_mail($user_email,$subject,$body_msg,array('MIME-Version: 1.0','Content-type: text/html; charset=iso-8859-1'));
						}
					}
					
				/*Welcome E-mail sent user to if it was first subscribe over*/
			}else{
				echo 'Not Subscribed';
			}
		}
	}else{
		echo 'Already Subscribed';
	}
	exit;
}
function ig_update_user_subscription(){
	global $wpdb;
	if($_POST['subscription_id']){
		foreach($_POST['subscription_id'] as $sub_id){
			$wpdb->query('DELETE  FROM '.$wpdb->prefix.'ig_subscribed_products WHERE id = "'.$sub_id.'"');
		}	
		echo get_subscribed_products($_POST['user_id']);
		
	}	
	exit;
}	

function check_autoresponders($email,$name){
	$options = get_option('InstaGenius-AdminOptions');
	$aweber_key = $options['aweber']['key'];
	$aweber_secret = $options['aweber']['secret'];
	$aweber_listid = $options['aweber']['listid'];
	$aweber_access_token = get_option('ig_aweber_access_token',null);
	$aweber_access_token_secret = get_option('ig_awaber_token_secret',null);
	$aweber_ac_id = get_option('ig_aweber_acount_id');
	$mailchimp_listid = $options['mailchimp']['listid'];
	$mailchimp_key = $options['mailchimp']['key'];
	$getR_key = $options['getresponse']['key'];
	$getR_list = $options['getresponse']['listid'];
	$sg_key = $options['sendgrid']['key'];
	$sg_list = $options['sendgrid']['listid'];
	$ml_key = $options['mailerlite']['key'];
	$ml_list = $options['mailerlite']['listid'];
	$sl_key = $options['sendlane']['key'];
	$sl_list = $options['sendlane']['listid'];
	$sl_hash = $options['sendlane']['hash'];
	$sl_domain = $options['sendlane']['domain'];
	$se_key = $options['sendengine']['key'];
	$ses_key = $options['ses']['key'];
	$ses_secret = $options['ses']['secret'];
	$ses_region = $options['ses']['region'];
	$mg_key = $options['mailgun']['key'];
	$mg_email = $options['mailgun']['email'];
	$mg_list = $options['mailgun']['listid'];
	$mp_enable = $options['mailpoet']['is_enable'];
	$mp_list = $options['mailpoet']['listid'];
	$ar_enable = $options['arigato']['is_enable'];
	$nbs_enable = $options['nbs']['is_enable'];
	$nbs_list = $options['nbs']['listid'];
	
	if($mailchimp_key && $mailchimp_listid){
		$status = 'subscribed'; // "subscribed" or "unsubscribed" or "cleaned" or "pending"
		$list_id = $mailchimp_listid; // where to get it read above
		$api_key = $mailchimp_key; // where to get it read above
		$merge_fields = array('FNAME' => $name,'LNAME' => '');
		 
		mailchimp_subscriber_status($email, $status, $list_id, $api_key, $merge_fields );
	}
	if($aweber_key && $aweber_secret && $aweber_listid && $aweber_access_token && $aweber_access_token_secret && $aweber_ac_id){
		$aweber = new AWeberAPI($aweber_key, $aweber_secret);
		try {
			$account = $aweber->getAccount($aweber_access_token, $aweber_access_token_secret);

			$list = $account->loadFromUrl("/accounts/{$aweber_ac_id}/lists/{$aweber_listid}");

			# create a subscriber
			$params = array(
				'email' => $email,
				'name' => $name,
			);

			$subscribers = $list->subscribers;
			$new_subscriber = $subscribers->create($params);

			# success!
			return "A new subscriber was added to the $list->name list!";

		} catch(AWeberAPIException $exc) {
			echo "Type: $exc->type<br>";
			echo "Msg : $exc->message<br>";
			exit(1);
		}

	}
	if($getR_key && $getR_list){
		$dir_path = plugin_dir_path(__FILE__);
		include ($dir_path.'includes/getresponse_api/GetResponseAPI3.class.php');
		$getresponse = new GetResponse($getR_key);
		$result = $getresponse->addContact(array(
			'name'              => $name,
			'email'             => $email,
			'dayOfCycle'        => 0,
			'ipAddress'         => $_SERVER['REMOTE_ADDR'],
			'campaign'          => array('campaignId' => $getR_list),
		));
		return 'Success';
	}
	if($sg_key && $sg_list){
		include ('includes/sendgrid_api/vendor/autoload.php');
		
		$apiKey = getenv($sg_key);
		$sg = new \SendGrid($apiKey);
		$request_body = json_decode('[
			{
				"email": "'.$email.'", 
				"first_name": "'.$name.'", 
				"last_name": ""
			}
		]');
		$response = $sg->client->contactdb()->recipients()->patch($request_body);
		$sg_return = json_decode($response->body());
		$sg_recipient_id = $sg_return->persisted_recipients[0];
		if($sg_recipient_id){
			$list_id = $sg_list;
			$recipient_id = $sg_recipient_id;
			$response = $sg->client->contactdb()->lists()->_($list_id)->recipients()->_($recipient_id)->post();
			if($response){
				return "success";
			}
		}
	}
	if($ml_key && $ml_list){
		// echo 'avesh';exit;
		include_once ('includes/mailerlite_api/Subscribers.php');
		$ML_Subscribers = new MailerLite\Subscribers( $ml_key );
		$subscriber = array(
			'email' => $email,
			'name' => $name
		);
		$subscriber = $ML_Subscribers->setId( $ml_list )->setAutoresponders(false)->add( $subscriber );
		/*echo '<pre>';
		print_r($subscriber);
		echo '</pre>';*/
		if($subscriber){
			return "success";
		}
		
	}
	if($sl_key && $sl_list && $sl_hash && $sl_domain){
		$integrations_api_key = $sl_key;
		$integrations_hash_key = $sl_hash;
		$list_id = $sl_list;
		$collect_leads_fname    = $name;
		$collect_leads_lname    = '';
		$collect_leads_email    = $email;
		$subscriber= "$collect_leads_fname $collect_leads_lname<$collect_leads_email>";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,"https://".$sl_domain.".sendlane.com/api/v1/list-subscribers-add" );  // use url of your app / account created
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POST,true);
		curl_setopt($ch, CURLOPT_POSTFIELDS,"api=$integrations_api_key&hash=$integrations_hash_key&email=$subscriber&list_id=$list_id");
		$result=curl_exec ($ch);
		$result=  json_decode($result);
		//print_r($result);exit;
		if($result){
			return "success";
		}
	}
	if($se_key){
		// echo $se_key;exit;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,"https://engine11.sendengine.net/api/subscribers/create");
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,"api_key=".$se_key."&first_name=".$name."&last_name=&email=".$email);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$server_output = curl_exec ($ch);
		curl_close ($ch);
		if($server_output){
			return "success";
		}
	}
	if($ses_key && $ses_secret && $ses_region){
		require_once('includes/amazon_ses_api/SimpleEmailService.php');
		require_once('includes/amazon_ses_api/SimpleEmailServiceMessage.php');
		require_once('includes/amazon_ses_api/SimpleEmailServiceRequest.php');
		
		if($ses_region == 'AWS_US_EAST_1'){
			$region_endpoint = 'email.us-east-1.amazonaws.com';
		}else if($ses_region == 'AWS_US_WEST_2'){
			$region_endpoint = 'email.us-west-2.amazonaws.com';
		}else if($ses_region == 'AWS_EU_WEST1'){
			$region_endpoint = 'email.eu-west-1.amazonaws.com';
		}
		$ses = new SimpleEmailService($ses_key, $ses_secret, $region_endpoint);
		$ses->verifyEmailAddress($email);
		if($ses){
			return "success";
		}
	}
	if($mg_key && $mg_email && $mg_list){
		include_once('includes/mailgun_api/vendor/autoload.php');
		$mailgun = new MailgunApi($mg_email, $mg_key);
		$members = array (array("subscribed" => "true", "address" => $email, "name" => $name));
		$add = $mailgun->addMultipleMembersToMailingList($mg_list, $members);
		if($add){
			return "success";
		}
	}
	if($mp_enable && $mp_list && get_option('ig_mailpoet_active')=='1'){
		global $wpdb;
		$get_id = $wpdb->get_row("SELECT id FROM `".$wpdb->prefix."mailpoet_subscribers` WHERE `email`='$email'");
		$get_id = $get_id->id;
		$mp_to_list = $wpdb->query("UPDATE `".$wpdb->prefix."mailpoet_subscriber_segment` SET `segment_id`='$mp_list' WHERE `subscriber_id`='$get_id'");
		if($mp_to_list){
			return 'success';
		}
	}
	if($ar_enable && get_option('ig_arigato_active')=='1'){
		global $wpdb;
		$ip = $_SERVER['REMOTE_ADDR'];
		$date = date('Y-m-d');
		$tbl_nm = $wpdb->prefix.'bft_users';
		$ar_to_list = $wpdb->query("INSERT INTO `$tbl_nm` (`email`,`name`,`status`,`date`,`ip`) VALUES ('$email','$name','1','$date','$ip')");
		if($ar_to_list){
			return 'success';
		}
	}
	if($nbs_enable && $nbs_list && get_option('ig_nbs_active')=='1'){
		global $wpdb;
		$get_id = $wpdb->get_row("SELECT id FROM `".$wpdb->prefix."nbs_subscribers` WHERE `email`='$email'");
		$get_id = $get_id->id;
		$nbs_to_list = $wpdb->query("UPDATE `".$wpdb->prefix."nbs_subscribers_to_lists` SET `slid`='$nbs_list' WHERE `sid`='$get_id'");
		if($nbs_to_list){
			return 'success';
		}
	}
}
/*function check_autoresponders_1(){
}
add_action('admin_init','check_autoresponders_1');*/
function mailchimp_subscriber_status( $email, $status, $list_id, $api_key, $merge_fields = array('FNAME' => '','LNAME' => '') ){
	$data = array(
		'apikey'        => $api_key,
    		'email_address' => $email,
		'status'        => $status,
		'merge_fields'  => $merge_fields
	);
	$mch_api = curl_init(); // initialize cURL connection
 
	curl_setopt($mch_api, CURLOPT_URL, 'https://' . substr($api_key,strpos($api_key,'-')+1) . '.api.mailchimp.com/3.0/lists/' . $list_id . '/members/' . md5(strtolower($data['email_address'])));
	curl_setopt($mch_api, CURLOPT_HTTPHEADER, array('Content-Type: application/json', 'Authorization: Basic '.base64_encode( 'user:'.$api_key )));
	curl_setopt($mch_api, CURLOPT_USERAGENT, 'PHP-MCAPI/2.0');
	curl_setopt($mch_api, CURLOPT_RETURNTRANSFER, true); // return the API response
	curl_setopt($mch_api, CURLOPT_CUSTOMREQUEST, 'PUT'); // method PUT
	curl_setopt($mch_api, CURLOPT_TIMEOUT, 10);
	curl_setopt($mch_api, CURLOPT_POST, true);
	curl_setopt($mch_api, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($mch_api, CURLOPT_POSTFIELDS, json_encode($data) ); // send data in json
 
	$result = curl_exec($mch_api);
	return $result;
}
/*
function ig_recommended_products(){
	echo 'recommended products - from shortcode function';
}
add_shortcode( 'recommended_products', 'ig_recommended_products' );
*/
/*
* AJAX Functions End
*/
/**
 * Register the plugin
 */
$InstaGenius = null;
add_action("init", create_function('', 'global $InstaGenius; $InstaGenius = new IG_InstaGenius();'));
//add_action( 'upgrader_process_complete',  array('IG_InstaGenius', 'install'),  10 ); 
register_activation_hook(basename( dirname( __FILE__)).'/'.basename(__FILE__), array('IG_InstaGenius', 'install'));
//add_action( 'plugins_loaded', 'install' );


add_option( 'cc_u_key', '14052fc727b4056b8d1503a2c305052b' );
function cc_authenticate_user($user,$key){
	if(get_option( 'cc_u_key' )){}
	else{add_option( 'cc_u_key', '14052fc727b4056b8d1503a2c305052b' );}
	$ukey = get_option( 'cc_u_key' );
	$url = "https://covertcommissions.com/gotest/login_check.php?user=$user&key=$key&uniqkey=$ukey";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); 
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);      
	curl_setopt($ch, CURLOPT_URL, $url);

	$result = curl_exec($ch);
	return json_decode($result);
}
function cc_get_available_packs(){
	$ukey = get_option( 'cc_u_key' );
	$mid = get_option( 'ccmember_id' );
	$url = "https://covertcommissions.com/gotest/get_packs.php?mid=$mid&uniqkey=$ukey";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); 
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);      
	curl_setopt($ch, CURLOPT_URL, $url);

	$result = curl_exec($ch);
	return json_decode($result);
}
function cc_get_package_data($package_id){
	$ukey = get_option( 'cc_u_key' );
	$mid = get_option( 'ccmember_id' );
	$url = "https://covertcommissions.com/gotest/banner.php?package_id=$package_id&mid=$mid&uniqkey=$ukey";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); 
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);      
	curl_setopt($ch, CURLOPT_URL, $url);

	$result = curl_exec($ch);
	return json_decode($result);
}
function mailchimp_curl_connect( $url, $request_type, $api_key, $data = array() ) {
	if( $request_type == 'GET' )
		$url .= '?' . http_build_query($data);
 
	$mch = curl_init();
	$headers = array(
		'Content-Type: application/json',
		'Authorization: Basic '.base64_encode( 'user:'. $api_key )
	);
	curl_setopt($mch, CURLOPT_URL, $url );
	curl_setopt($mch, CURLOPT_HTTPHEADER, $headers);
	//curl_setopt($mch, CURLOPT_USERAGENT, 'PHP-MCAPI/2.0');
	curl_setopt($mch, CURLOPT_RETURNTRANSFER, true); // do not echo the result, write it into variable
	curl_setopt($mch, CURLOPT_CUSTOMREQUEST, $request_type); // according to MailChimp API: POST/GET/PATCH/PUT/DELETE
	curl_setopt($mch, CURLOPT_TIMEOUT, 10);
	curl_setopt($mch, CURLOPT_SSL_VERIFYPEER, false); // certificate verification for TLS/SSL connection
 
	if( $request_type != 'GET' ) {
		curl_setopt($mch, CURLOPT_POST, true);
		curl_setopt($mch, CURLOPT_POSTFIELDS, json_encode($data) ); // send data in json
	}
 
	return curl_exec($mch);
}
/**/